﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;

namespace S3Browser
{
    class ListViewItemComparer : IComparer
    {
        private int col;
        private System.Windows.Forms.SortOrder order;
        private String ComparerBucketName;

        public ListViewItemComparer() 
        {
            col = 0;
            order = System.Windows.Forms.SortOrder.Ascending;
            ComparerBucketName = "";
        }

        public ListViewItemComparer(int column, System.Windows.Forms.SortOrder order, String CurrentBucketName) 
        {
            col = column;
            this.order = order;
            ComparerBucketName = CurrentBucketName;
        }

        public int Compare(object x, object y) 
        {
            int returnVal = -1;
            System.Windows.Forms.ListViewItem MyListViewItemX = (System.Windows.Forms.ListViewItem)x;
            System.Windows.Forms.ListViewItem MyListViewItemY = (System.Windows.Forms.ListViewItem)y;
            ItemObject MyItemObjectX = (ItemObject)MyListViewItemX.Tag;
            ItemObject MyItemObjectY = (ItemObject)MyListViewItemY.Tag;


            if (ComparerBucketName == "")
            {
                if (col == 0)
                {
                    returnVal = String.Compare(MyItemObjectX.SortName, MyItemObjectY.SortName);
                }
                else if (col == 1)
                {
                    returnVal = DateTime.Compare(MyItemObjectX.SortDate, MyItemObjectY.SortDate);
                }
            }
            else
            {
                if (col == 0)
                {
                    returnVal = String.Compare(MyItemObjectX.SortName, MyItemObjectY.SortName);
                }
                else if (col == 1)
                {
                    returnVal = Decimal.Compare(MyItemObjectX.Size, MyItemObjectY.Size);
                }
                else if (col == 2)
                {
                    returnVal = DateTime.Compare(MyItemObjectX.SortDate, MyItemObjectY.SortDate);
                }
                else if (col == 3)
                {
                    returnVal = String.Compare(MyItemObjectX.SortFileType, MyItemObjectY.SortFileType);
                }
            }

            //Determine whether the sort order is descending.
            if (order == System.Windows.Forms.SortOrder.Descending)
            {
                //Invert the value returned by String.Compare.
                returnVal *= -1;
            }
            
            return returnVal;
        }

    }

}
